/***********************************************************************
/* 
/* serial.c
/*
/* Description: Functions relating to the serial port initialization
/* and any associated functions pertaining the serial port.
/*
/* REVISED: 04-16-2010   MODIFIED to remove the carriage return and linefeed 
/* for use in the wireless weather stations.
/* 
/* 
/*
/***********************************************************************/


#include <stdio.h>
#include <usart.h>

#include "serial.h"


// Following used in conjunction with the hardware UART
// Uncomment according to the clock speed of the PIC in use.  
//#define FOURMHZ
#define EIGHTMHZ
//#define TENMHZ

// Required by library for code compatibility with this PIC18
#define EAUSART_V5

/***********************************************************************
/* 
/*
/* 
/* 
/*
/***********************************************************************/
void Serialcommservice(void) {

  usart_init();

  return;
}

/***********************************************************************
/* 
/*
/* 
/* 
/*
/***********************************************************************/
void usart_init() {

#ifdef	FOURMHZ
  // This current configuration assumes that the Microchip PIC clock is at 4MHz, Rx interrupts, asynch,
  // 8 bit, 1 stop bit, no parity, 9600 baud
  OpenUSART(USART_TX_INT_OFF &
            USART_RX_INT_ON &
            USART_ASYNCH_MODE &
            USART_EIGHT_BIT &
            USART_CONT_RX &
            USART_BRGH_HIGH,
            0x19);

#endif
#ifdef	EIGHTMHZ
  // This current configuration assumes that the Microchip PIC clock is at 8MHz, Rx interrupts, asynch,
  // 8 bit, 1 stop bit, no parity, 9600 baud
  OpenUSART(USART_TX_INT_OFF &
            USART_RX_INT_ON &
            USART_ASYNCH_MODE &
            USART_EIGHT_BIT &
            USART_CONT_RX &
            USART_BRGH_HIGH,
            0x33);

#endif
#ifdef TENMHZ
  // This current configuration assumes that the Microchip PIC clock is at 10MHz, Rx interrupts, asynch,
  // 8 bit, 1 stop bit, no parity, 9600 baud
  OpenUSART(USART_TX_INT_OFF &
            USART_RX_INT_ON &
            USART_ASYNCH_MODE &
            USART_EIGHT_BIT &
            USART_CONT_RX &
            USART_BRGH_HIGH,
            0x40);
#endif


return;
}



